#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Magenta
#property indicator_color2 Blue

//--- input parameters

//--- buffers
double f_[];
double f[];
double p_[];
double p[];
datetime TIME[];
double   fakt[];
double   prognoz[];
int shetchik;
extern string File_Name="SUZP.csv";
int T;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   int Handle,Skip;
   double kol_vo, kp;
   string Text,Str_DtTm;
   datetime Dat_DtTm;
   Handle=FileOpen(File_Name,FILE_CSV|FILE_READ,",");//  
   if(Handle<0) // Failure when opening a file
     {
      if(GetLastError()==4103)
         Alert("There is no file named ",File_Name);
      else
         Alert("Error when opening a file ",File_Name);
      PlaySound("Bzrrr.wav");
      return(0);
     }
   while(FileIsEnding(Handle)==false)
   {
   Skip =FileReadString(Handle);//
   if(FileIsLineEnding(Handle))shetchik=shetchik+1;
   if(FileIsEnding(Handle)){FileClose(Handle);}// -     
   }
   Handle=FileOpen(File_Name,FILE_CSV|FILE_READ,",");//  
   if(Handle<0) // Failure when opening a file
     {
      if(GetLastError()==4103)
         Alert("There is no file named ",File_Name);
      else
         Alert("Error when opening a file ",File_Name);
      PlaySound("Bzrrr.wav");
      return(0);
     }
   ArrayInitialize(TIME,0);
   ArrayInitialize(fakt,0);
   ArrayInitialize(prognoz,0);
   ArrayResize(TIME,shetchik);
   ArrayResize(fakt,shetchik);
   ArrayResize(prognoz,shetchik);
   for(int k=shetchik-2;k>=0;k--)
     {
         //--------------------------------------------------------- 5 --
         Str_DtTm =FileReadString(Handle);//  
         Text     =FileReadString(Handle);//  
         //--------------------------------------------------------- 6 --
         Dat_DtTm=StrToTime(Str_DtTm);   //    
         kol_vo=StringToDouble(Text);   //     
         Text     =FileReadString(Handle);
         kp=StringToDouble(Text);
         Text     =FileReadString(Handle);
         TIME[k]=Dat_DtTm;
         fakt[k]=kol_vo;
         prognoz[k]=kp;
         //--------------------------------------------------------- 7 --
         if(FileIsEnding(Handle)==true){ Print(" =",TimeToString(Dat_DtTm));break;}// 

     }
FileClose(Handle);
T=shetchik-1;
//---- indicators
   IndicatorBuffers(4);
   SetIndexBuffer(0,f_);
   SetIndexBuffer(1,p_);
   SetIndexBuffer(2,f);
   SetIndexBuffer(3,p);
   IndicatorDigits(Digits+1);
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted(),limit;

   if(counted_bars>0)
      counted_bars--;
   limit=Bars-counted_bars-1;

   for(int i=limit;i>=0;i--)
   {

     for (int t=T;t>=0;t--)
     {
     if (t!=0)
     {
     if(Time[i] >= TIME[t] && Time[i] < TIME[t-1])
     {
     f[i]=fakt[t];
     p[i]=prognoz[t];
     T=t;     
     break;
     }
     }
     }
   }
  for(i=limit;i>=0;i--)
  {
  if (f[i]!=0.0)f_[i]=f[i];//,     
  if (f[i]==0.0)f_[i]=f[i+1];//     
  if (p[i]!=0.0)p_[i]=p[i];//,     
  if (p[i]==0.0)p_[i]=p[i+1];//    
  }
   return(0);
  }
//+------------------------------------------------------------------+